Package: fig2dev / 1:3.2.7a-5+deb10u1

40_circle_arrowhead.patch Patch series | download
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454
455
456
457
458
459
460
461
462
463
464
465
466
467
468
469
470
471
472
473
474
475
476
477
478
479
480
481
482
483
484
485
486
487
488
489
490
491
492
493
494
495
496
497
498
499
500
501
502
503
504
505
506
507
508
509
510
511
512
513
514
515
516
517
518
519
520
521
522
523
524
525
526
527
528
529
530
531
532
533
534
535
536
537
538
539
540
541
542
543
544
545
546
547
548
549
550
551
552
553
554
555
556
557
558
559
560
561
562
563
564
565
566
567
568
569
570
571
572
573
574
575
576
577
578
579
580
581
582
583
584
585
586
587
588
589
590
591
592
593
594
595
596
597
598
599
600
601
602
603
604
605
606
607
608
609
610
611
612
613
614
615
616
617
618
619
620
621
622
623
624
625
626
627
628
629
630
631
632
633
634
635
636
637
638
639
640
641
642
643
644
645
646
647
648
649
650
651
652
653
654
655
656
657
658
659
660
661
662
663
664
665
666
667
668
669
670
671
672
673
674
675
676
677
678
679
680
681
682
683
684
685
From: Thomas Loimer <thomas.loimer@tuwien.ac.at>
Date: Fri Jul 26 23:25:50 2019 +0200
Bug-Debian: https://bugs.debian.org/933075
Bug: https://sourceforge.net/p/mcj/tickets/52/
Origin: https://sourceforge.net/p/mcj/fig2dev/ci/03ea45
Subject: Allow circle arrowheads when mag >= 42, ticket #52
 Circle and half-circle arrowheads would be drawn with 40 + mag/4 points by
 calc_arrow() in bound.c. However, the point arrays passed to calc_arrow()
 would only contain 50 points. With a magnification >= 42, a buffer overrun
 would occur. Simply use 40 points, independent of magnification.
 .
 This fixes CVE-2019-14275

--- a/fig2dev/bound.c
+++ b/fig2dev/bound.c
@@ -905,7 +905,7 @@ calc_arrow(int x1, int y1, int x2, int y
 	    /*
 	     * CIRCLE and HALF-CIRCLE arrowheads
 	     *
-	     * We approximate circles with (40+zoom)/4 points
+	     * We approximate circles with 40 points
 	     */
 	    double	maxx;
 	    double	fix_x, fix_y, xs, ys;
@@ -936,8 +936,8 @@ calc_arrow(int x1, int y1, int x2, int y
 	    dy = my - ys;
 	    fix_x = xs + (dx / 2.0);
 	    fix_y = ys + (dy / 2.0);
-	    /* choose number of points for circle - 40+mag/4 points */
-	    *npoints = np = round(mag/4.0) + 40;
+	    /* choose number of points for circle */
+	    *npoints = np = 40;
 
 	    if (type == 5) {
 		/* full circle */
--- a/fig2dev/tests/read.at
+++ b/fig2dev/tests/read.at
@@ -208,6 +208,29 @@ EOF
 ],1,ignore,ignore)
 AT_CLEANUP
 
+AT_SETUP([process circle arrow at mag > 42, ticket #52])
+AT_KEYWORDS([bound.c])
+# With the -fsanitize=address option, a magnification >= 42 triggers an error.
+# Without the -fsanitize=address option, a segfault only results
+# if the array is accessed far enough from its valid range;
+# Use a magnification of 420.
+AT_CHECK([fig2dev -L box <<EOF
+#FIG 3.2
+Landscape
+Center
+Inches
+Letter
+42000.0
+Single
+-2
+1200 2
+2 1 0 1 0 7 50 -1 -1 0.0 0 0 -1 1 0 2
+	5 0 1.0 60.0 120.0
+	 0 0 600 0
+EOF
+], 0, ignore)
+AT_CLEANUP
+
 AT_BANNER([Dynamically allocate picture file name.])
 
 AT_SETUP([prepend fig file path to picture file name])
--- a/fig2dev/tests/testsuite
+++ b/fig2dev/tests/testsuite
@@ -631,30 +631,31 @@ at_help_all="1;input.at:25;do not overwr
 23;read.at:148;survive debian bugs #881143, #881144;font pic tikz;
 24;read.at:177;reject out-of-range pattern, debian bug #881396;read.c;
 25;read.at:187;survive debian bug #890016;read1_3.c;
-26;read.at:213;prepend fig file path to picture file name;read.c picfilename;
-27;output.at:24;compare arrow tips with template;eps arrows;
-28;output.at:50;honor SOURCE_DATE_EPOCH environment variable;eps creationdate source_date_epoch;
-29;output.at:57;fail on text in SOURCE_DATE_EPOCH;eps creationdate source_date_epoch;
-30;output.at:107;ignore -G option;pict2e options;
-31;output.at:119;compare patterns with template;svg pattern creationdate;
-32;output.at:152;compare fills with arrows to template;svg arrows pattern fill creationdate;
-33;output.at:161;conditionally allocate \\XFigu;tikz newdimen;
-34;output.at:183;pattern with stroke color equal to fill color;tikz pattern;
-35;bitmaps.at:25;gif;bitmaps gif;
-36;bitmaps.at:33;jpeg;bitmaps jpeg jpg;
-37;bitmaps.at:41;pcx;bitmaps pcx;
-38;bitmaps.at:49;png;bitmaps png;
-39;bitmaps.at:57;png with smoothing;bitmaps png smoothing;
-40;bitmaps.at:65;ppm;bitmaps ppm;
-41;bitmaps.at:73;tiff;bitmaps tiff tif;
-42;bitmaps.at:81;xbm;bitmaps xbm;
-43;bitmaps.at:91;xbm with smoothing;bitmaps xbm smoothing;
-44;bitmaps.at:101;xpm;bitmaps xpm;
-45;bitmaps.at:115;eps with acscii preview;bitmaps tmpfile eps-ascii;
-46;bitmaps.at:123;eps with tiff preview;bitmaps tmpfile eps-tiff;
-47;bitmaps.at:132;epsi;embed epsi;
-48;bitmaps.at:144;postscript, created by fig2dev;embed ps;
-49;bitmaps.at:191;postscript, created by latex;embed ps;
+26;read.at:211;process circle arrow at mag > 42, ticket #52;bound.c;
+27;read.at:236;prepend fig file path to picture file name;read.c picfilename;
+28;output.at:24;compare arrow tips with template;eps arrows;
+29;output.at:50;honor SOURCE_DATE_EPOCH environment variable;eps creationdate source_date_epoch;
+30;output.at:57;fail on text in SOURCE_DATE_EPOCH;eps creationdate source_date_epoch;
+31;output.at:107;ignore -G option;pict2e options;
+32;output.at:119;compare patterns with template;svg pattern creationdate;
+33;output.at:152;compare fills with arrows to template;svg arrows pattern fill creationdate;
+34;output.at:161;conditionally allocate \\XFigu;tikz newdimen;
+35;output.at:183;pattern with stroke color equal to fill color;tikz pattern;
+36;bitmaps.at:25;gif;bitmaps gif;
+37;bitmaps.at:33;jpeg;bitmaps jpeg jpg;
+38;bitmaps.at:41;pcx;bitmaps pcx;
+39;bitmaps.at:49;png;bitmaps png;
+40;bitmaps.at:57;png with smoothing;bitmaps png smoothing;
+41;bitmaps.at:65;ppm;bitmaps ppm;
+42;bitmaps.at:73;tiff;bitmaps tiff tif;
+43;bitmaps.at:81;xbm;bitmaps xbm;
+44;bitmaps.at:91;xbm with smoothing;bitmaps xbm smoothing;
+45;bitmaps.at:101;xpm;bitmaps xpm;
+46;bitmaps.at:115;eps with acscii preview;bitmaps tmpfile eps-ascii;
+47;bitmaps.at:123;eps with tiff preview;bitmaps tmpfile eps-tiff;
+48;bitmaps.at:132;epsi;embed epsi;
+49;bitmaps.at:144;postscript, created by fig2dev;embed ps;
+50;bitmaps.at:191;postscript, created by latex;embed ps;
 "
 # List of the all the test groups.
 at_groups_all=`$as_echo "$at_help_all" | sed 's/;.*//'`
@@ -668,7 +669,7 @@ at_fn_validate_ranges ()
   for at_grp
   do
     eval at_value=\$$at_grp
-    if test $at_value -lt 1 || test $at_value -gt 49; then
+    if test $at_value -lt 1 || test $at_value -gt 50; then
       $as_echo "invalid test group: $at_value" >&2
       exit 1
     fi
@@ -1056,29 +1057,29 @@ at_banner_text_4="Find and decompress em
 # Banner 5. read.at:20
 # Category starts at test group 12.
 at_banner_text_5="Sanitize input files in read.c."
-# Banner 6. read.at:211
-# Category starts at test group 26.
+# Banner 6. read.at:234
+# Category starts at test group 27.
 at_banner_text_6="Dynamically allocate picture file name."
 # Banner 7. output.at:22
-# Category starts at test group 27.
+# Category starts at test group 28.
 at_banner_text_7="Test PostScript output language."
 # Banner 8. output.at:66
-# Category starts at test group 30.
+# Category starts at test group 31.
 at_banner_text_8="Test pict2e output language."
 # Banner 9. output.at:118
-# Category starts at test group 31.
+# Category starts at test group 32.
 at_banner_text_9="Test svg output language."
 # Banner 10. output.at:159
-# Category starts at test group 33.
+# Category starts at test group 34.
 at_banner_text_10="Test tikz output language."
 # Banner 11. bitmaps.at:20
-# Category starts at test group 35.
+# Category starts at test group 36.
 at_banner_text_11="Create and embed bitmaps in fig-file."
 # Banner 12. bitmaps.at:111
-# Category starts at test group 45.
+# Category starts at test group 46.
 at_banner_text_12="Creation of temporary files."
 # Banner 13. bitmaps.at:130
-# Category starts at test group 47.
+# Category starts at test group 48.
 at_banner_text_13="Embed postscript variants."
 
 # Take any -C into account.
@@ -3344,19 +3345,78 @@ $at_traceon; }
 read at_status <"$at_status_file"
 #AT_STOP_25
 #AT_START_26
-at_fn_group_banner 26 'read.at:213' \
-  "prepend fig file path to picture file name" "     " 6
+at_fn_group_banner 26 'read.at:211' \
+  "process circle arrow at mag > 42, ticket #52" "   " 5
 at_xfail=no
 (
   $as_echo "26. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
+# With the -fsanitize=address option, a magnification >= 42 triggers an error.
+# Without the -fsanitize=address option, a segfault only results
+# if the array is accessed far enough from its valid range;
+# Use a magnification of 420.
 { set +x
-$as_echo "$at_srcdir/read.at:215: fig2dev -L eps \$srcdir/data/boxwimg.fig | \\
+$as_echo "$at_srcdir/read.at:217: fig2dev -L box <<EOF
+#FIG 3.2
+Landscape
+Center
+Inches
+Letter
+42000.0
+Single
+-2
+1200 2
+2 1 0 1 0 7 50 -1 -1 0.0 0 0 -1 1 0 2
+	5 0 1.0 60.0 120.0
+	 0 0 600 0
+EOF
+"
+at_fn_check_prepare_notrace 'an embedded newline' "read.at:217"
+( $at_check_trace; fig2dev -L box <<EOF
+#FIG 3.2
+Landscape
+Center
+Inches
+Letter
+42000.0
+Single
+-2
+1200 2
+2 1 0 1 0 7 50 -1 -1 0.0 0 0 -1 1 0 2
+	5 0 1.0 60.0 120.0
+	 0 0 600 0
+EOF
+
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo stdout:; cat "$at_stdout"
+at_fn_check_status 0 $at_status "$at_srcdir/read.at:217"
+$at_failed && at_fn_log_failure
+$at_traceon; }
+
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_26
+#AT_START_27
+at_fn_group_banner 27 'read.at:236' \
+  "prepend fig file path to picture file name" "     " 6
+at_xfail=no
+(
+  $as_echo "27. $at_setup_line: testing $at_desc ..."
+  $at_traceon
+
+
+{ set +x
+$as_echo "$at_srcdir/read.at:238: fig2dev -L eps \$srcdir/data/boxwimg.fig | \\
 	\$FGREP \"% Begin Imported EPS File: \$srcdir/data/line.eps\"
 "
-at_fn_check_prepare_notrace 'an embedded newline' "read.at:215"
+at_fn_check_prepare_notrace 'an embedded newline' "read.at:238"
 ( $at_check_trace; fig2dev -L eps $srcdir/data/boxwimg.fig | \
 	$FGREP "% Begin Imported EPS File: $srcdir/data/line.eps"
 
@@ -3365,7 +3425,7 @@ at_status=$? at_failed=false
 $at_check_filter
 at_fn_diff_devnull "$at_stderr" || at_failed=:
 echo stdout:; cat "$at_stdout"
-at_fn_check_status 0 $at_status "$at_srcdir/read.at:215"
+at_fn_check_status 0 $at_status "$at_srcdir/read.at:238"
 $at_failed && at_fn_log_failure
 $at_traceon; }
 
@@ -3373,13 +3433,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_26
-#AT_START_27
-at_fn_group_banner 27 'output.at:24' \
+#AT_STOP_27
+#AT_START_28
+at_fn_group_banner 28 'output.at:24' \
   "compare arrow tips with template" "               " 7
 at_xfail=no
 (
-  $as_echo "27. $at_setup_line: testing $at_desc ..."
+  $as_echo "28. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3425,13 +3485,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_27
-#AT_START_28
-at_fn_group_banner 28 'output.at:50' \
+#AT_STOP_28
+#AT_START_29
+at_fn_group_banner 29 'output.at:50' \
   "honor SOURCE_DATE_EPOCH environment variable" "   " 7
 at_xfail=no
 (
-  $as_echo "28. $at_setup_line: testing $at_desc ..."
+  $as_echo "29. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3456,13 +3516,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_28
-#AT_START_29
-at_fn_group_banner 29 'output.at:57' \
+#AT_STOP_29
+#AT_START_30
+at_fn_group_banner 30 'output.at:57' \
   "fail on text in SOURCE_DATE_EPOCH" "              " 7
 at_xfail=no
 (
-  $as_echo "29. $at_setup_line: testing $at_desc ..."
+  $as_echo "30. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3487,13 +3547,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_29
-#AT_START_30
-at_fn_group_banner 30 'output.at:107' \
+#AT_STOP_30
+#AT_START_31
+at_fn_group_banner 31 'output.at:107' \
   "ignore -G option" "                               " 8
 at_xfail=no
 (
-  $as_echo "30. $at_setup_line: testing $at_desc ..."
+  $as_echo "31. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3530,13 +3590,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_30
-#AT_START_31
-at_fn_group_banner 31 'output.at:119' \
+#AT_STOP_31
+#AT_START_32
+at_fn_group_banner 32 'output.at:119' \
   "compare patterns with template" "                 " 9
 at_xfail=no
 (
-  $as_echo "31. $at_setup_line: testing $at_desc ..."
+  $as_echo "32. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3562,13 +3622,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_31
-#AT_START_32
-at_fn_group_banner 32 'output.at:152' \
+#AT_STOP_32
+#AT_START_33
+at_fn_group_banner 33 'output.at:152' \
   "compare fills with arrows to template" "          " 9
 at_xfail=no
 (
-  $as_echo "32. $at_setup_line: testing $at_desc ..."
+  $as_echo "33. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3591,13 +3651,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_32
-#AT_START_33
-at_fn_group_banner 33 'output.at:161' \
+#AT_STOP_33
+#AT_START_34
+at_fn_group_banner 34 'output.at:161' \
   "conditionally allocate \\XFigu" "                  " 10
 at_xfail=no
 (
-  $as_echo "33. $at_setup_line: testing $at_desc ..."
+  $as_echo "34. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3656,13 +3716,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_33
-#AT_START_34
-at_fn_group_banner 34 'output.at:183' \
+#AT_STOP_34
+#AT_START_35
+at_fn_group_banner 35 'output.at:183' \
   "pattern with stroke color equal to fill color" "  " 10
 at_xfail=no
 (
-  $as_echo "34. $at_setup_line: testing $at_desc ..."
+  $as_echo "35. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3701,13 +3761,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_34
-#AT_START_35
-at_fn_group_banner 35 'bitmaps.at:25' \
+#AT_STOP_35
+#AT_START_36
+at_fn_group_banner 36 'bitmaps.at:25' \
   "gif" "                                            " 11
 at_xfail=no
 (
-  $as_echo "35. $at_setup_line: testing $at_desc ..."
+  $as_echo "36. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3735,13 +3795,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_35
-#AT_START_36
-at_fn_group_banner 36 'bitmaps.at:33' \
+#AT_STOP_36
+#AT_START_37
+at_fn_group_banner 37 'bitmaps.at:33' \
   "jpeg" "                                           " 11
 at_xfail=no
 (
-  $as_echo "36. $at_setup_line: testing $at_desc ..."
+  $as_echo "37. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3769,13 +3829,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_36
-#AT_START_37
-at_fn_group_banner 37 'bitmaps.at:41' \
+#AT_STOP_37
+#AT_START_38
+at_fn_group_banner 38 'bitmaps.at:41' \
   "pcx" "                                            " 11
 at_xfail=no
 (
-  $as_echo "37. $at_setup_line: testing $at_desc ..."
+  $as_echo "38. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3803,13 +3863,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_37
-#AT_START_38
-at_fn_group_banner 38 'bitmaps.at:49' \
+#AT_STOP_38
+#AT_START_39
+at_fn_group_banner 39 'bitmaps.at:49' \
   "png" "                                            " 11
 at_xfail=no
 (
-  $as_echo "38. $at_setup_line: testing $at_desc ..."
+  $as_echo "39. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3837,13 +3897,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_38
-#AT_START_39
-at_fn_group_banner 39 'bitmaps.at:57' \
+#AT_STOP_39
+#AT_START_40
+at_fn_group_banner 40 'bitmaps.at:57' \
   "png with smoothing" "                             " 11
 at_xfail=no
 (
-  $as_echo "39. $at_setup_line: testing $at_desc ..."
+  $as_echo "40. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3871,13 +3931,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_39
-#AT_START_40
-at_fn_group_banner 40 'bitmaps.at:65' \
+#AT_STOP_40
+#AT_START_41
+at_fn_group_banner 41 'bitmaps.at:65' \
   "ppm" "                                            " 11
 at_xfail=no
 (
-  $as_echo "40. $at_setup_line: testing $at_desc ..."
+  $as_echo "41. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3905,13 +3965,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_40
-#AT_START_41
-at_fn_group_banner 41 'bitmaps.at:73' \
+#AT_STOP_41
+#AT_START_42
+at_fn_group_banner 42 'bitmaps.at:73' \
   "tiff" "                                           " 11
 at_xfail=no
 (
-  $as_echo "41. $at_setup_line: testing $at_desc ..."
+  $as_echo "42. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3939,13 +3999,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_41
-#AT_START_42
-at_fn_group_banner 42 'bitmaps.at:81' \
+#AT_STOP_42
+#AT_START_43
+at_fn_group_banner 43 'bitmaps.at:81' \
   "xbm" "                                            " 11
 at_xfail=no
 (
-  $as_echo "42. $at_setup_line: testing $at_desc ..."
+  $as_echo "43. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -3975,13 +4035,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_42
-#AT_START_43
-at_fn_group_banner 43 'bitmaps.at:91' \
+#AT_STOP_43
+#AT_START_44
+at_fn_group_banner 44 'bitmaps.at:91' \
   "xbm with smoothing" "                             " 11
 at_xfail=no
 (
-  $as_echo "43. $at_setup_line: testing $at_desc ..."
+  $as_echo "44. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4011,13 +4071,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_43
-#AT_START_44
-at_fn_group_banner 44 'bitmaps.at:101' \
+#AT_STOP_44
+#AT_START_45
+at_fn_group_banner 45 'bitmaps.at:101' \
   "xpm" "                                            " 11
 at_xfail=no
 (
-  $as_echo "44. $at_setup_line: testing $at_desc ..."
+  $as_echo "45. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4049,13 +4109,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_44
-#AT_START_45
-at_fn_group_banner 45 'bitmaps.at:115' \
+#AT_STOP_45
+#AT_START_46
+at_fn_group_banner 46 'bitmaps.at:115' \
   "eps with acscii preview" "                        " 12
 at_xfail=no
 (
-  $as_echo "45. $at_setup_line: testing $at_desc ..."
+  $as_echo "46. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4083,13 +4143,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_45
-#AT_START_46
-at_fn_group_banner 46 'bitmaps.at:123' \
+#AT_STOP_46
+#AT_START_47
+at_fn_group_banner 47 'bitmaps.at:123' \
   "eps with tiff preview" "                          " 12
 at_xfail=no
 (
-  $as_echo "46. $at_setup_line: testing $at_desc ..."
+  $as_echo "47. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4115,13 +4175,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_46
-#AT_START_47
-at_fn_group_banner 47 'bitmaps.at:132' \
+#AT_STOP_47
+#AT_START_48
+at_fn_group_banner 48 'bitmaps.at:132' \
   "epsi" "                                           " 13
 at_xfail=no
 (
-  $as_echo "47. $at_setup_line: testing $at_desc ..."
+  $as_echo "48. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4151,13 +4211,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_47
-#AT_START_48
-at_fn_group_banner 48 'bitmaps.at:144' \
+#AT_STOP_48
+#AT_START_49
+at_fn_group_banner 49 'bitmaps.at:144' \
   "postscript, created by fig2dev" "                 " 13
 at_xfail=no
 (
-  $as_echo "48. $at_setup_line: testing $at_desc ..."
+  $as_echo "49. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4232,13 +4292,13 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_48
-#AT_START_49
-at_fn_group_banner 49 'bitmaps.at:191' \
+#AT_STOP_49
+#AT_START_50
+at_fn_group_banner 50 'bitmaps.at:191' \
   "postscript, created by latex" "                   " 13
 at_xfail=no
 (
-  $as_echo "49. $at_setup_line: testing $at_desc ..."
+  $as_echo "50. $at_setup_line: testing $at_desc ..."
   $at_traceon
 
 
@@ -4314,4 +4374,4 @@ $at_traceon; }
   $at_times_p && times >"$at_times_file"
 ) 5>&1 2>&1 7>&- | eval $at_tee_pipe
 read at_status <"$at_status_file"
-#AT_STOP_49
+#AT_STOP_50